// Functions for Ev Ware GUI
// Coded by Atom for The Evolutionary Informatics Lab.

// On Load
jQuery(document).ready(function() {								
	// Unhide tab, if hidden
	var isHidden = jQuery("#tabs #simulation").hasClass("hidden");
	if (isHidden) jQuery("#tabs #simulation").addClass("visible").removeClass("hidden");
				
	//Initialize Shadowbox
	var opts = { onClose: function(){if (interHistoryID) clearInterval(interHistoryID);} }; 
	Shadowbox.init(opts);

	//Vars
	InitialSlideVal = 0.9;
	Speed = Math.floor(((1 - InitialSlideVal) * 1000) + 1);
	CurrentBindingsMode = ($('rdbEvSites').checked ? EV_BINDINGS_MODE : ($('rdbAllZeros').checked ? ZEROES_BINDINGS_MODE : RANDOM_BINDINGS_MODE));
	objSearch1 = new SearchObject();
	objSearch2 = new SearchObject();
	objMultiRun = new MultiRunObject();
	interID = null;
	interHistoryID = null;
	arrTo = new Array();
	IsCompleted = false;
	currentSearchResultsString1 = null;
	currentSearchResultsString2 = null;
	
	// Slider control for speed
	new Control.Slider('speedHandle', 'speedTrack', {
		sliderValue: InitialSlideVal,
		onSlide: function(v){
				Speed = Math.floor(((1 - v) * 1000) + 1); 
				if (interID) {
					$('btnStop').click(); 
					while (arrTo.length > 0) clearTimeout(arrTo.pop());
					arrTo.push(setTimeout("$('btnStartSearch').click();", 200));
				}
		}
	});

	//Assign event handlers
	
	$('rdbEvSites').onclick = function() {CurrentBindingsMode = EV_BINDINGS_MODE; $('btnStop').click(); ResetSearch();}
	$('rdbAllZeros').onclick = function() {CurrentBindingsMode = ZEROES_BINDINGS_MODE; $('btnStop').click(); ResetSearch();}
	$('rdbRandomSites').onclick = function() {CurrentBindingsMode = RANDOM_BINDINGS_MODE; $('btnStop').click(); ResetSearch();}
	
	$('txtSteps').onblur = function() {
		var totalOrgs = 2;
		var ddl = $('ddlAlgorithms1');
		if (SearchTypes[ddl.options[ddl.selectedIndex].value] == "Ev Search") totalOrgs += parseInt($('txtOrganisms1').value);
		ddl = $('ddlAlgorithms2');
		if (SearchTypes[ddl.options[ddl.selectedIndex].value] == "Ev Search") totalOrgs += parseInt($('txtOrganisms2').value);
	
		this.value = parseInt(this.value, 10) > parseInt(1000 / totalOrgs) ? parseInt(1000 / totalOrgs) : parseInt(this.value, 10);
		this.value = parseInt(this.value, 10) > 100 ? 100 : this.value;
	}
	
	$('txtSteps').onkeypress = function(e) {
		var evt = (e) ? e : window.event;
		var key = (evt.keyCode) ? evt.keyCode : evt.which;
		
		return isNumeric(key);
	}
	
	$('btnStartSearch').onclick = function() {
		if (interID) clearInterval(interID);
		interID = setInterval(typeof objMultiRun != "undefined" && objMultiRun.CurrentlyOn ? "TakeStepForwardMulti();" : "TakeStepForward();", Speed);
	}
	
	$('btnStepForward').onclick = function() {
		var btnVal = $('btnStepForward').value;
		var tmpID = interID; //Save this to check if we were in auto search later. If we were, we'll want to reusme auto search after we do these steps forward.
	
		$('btnStop').click();
		
		if (IsCompleted) {
			NotifyUserSearchCompleted();
		} else {
			$('btnStepForward').disabled = true;
			$('btnStepForward').value = "Stepping...";
			setTimeout("for (n = 0; n < parseInt($('txtSteps').value, 10) && n < 100 && !IsCompleted; n++) {TakeStepForward();} $('btnStepForward').disabled = false; $('btnStepForward').value = '" + btnVal + "';" + (tmpID ? "$('btnStartSearch').click();" : ""), 1);
		}
	}
	
	$('btnReset').onclick = function() {
		if (interID) clearInterval(interID);
		interID = null;
		ResetSearch();
	}
	
	$('btnStop').onclick = function() {
		if (interID) clearInterval(interID);
		interID = null;
		while (arrTo.length > 0) clearTimeout(arrTo.pop()); //clear any timeouts set to restart search
	}
	
	$('ddlAlgorithms1').onchange = function() {
		//Stop and reset search
		$('btnStop').click();
		ResetSearch();
	
		if (SearchTypes[this.options[this.selectedIndex].value] == "Ev Search") {
			$('divAlgorithmControls1').style.height = null;
			Effect.BlindDown('SearchOneAdvancedOptions', { duration: 0.5 });
		} else {
			Effect.BlindUp('SearchOneAdvancedOptions', { duration: 0.5, afterFinish: function() {$('divAlgorithmControls1').style.height = "32px";}});
		}
	}
	
	$('ddlAlgorithms2').onchange = function() {
		//Stop and reset search
		$('btnStop').click();
		ResetSearch();
	
		if (SearchTypes[this.options[this.selectedIndex].value] == "Ev Search") {
				$('divAlgorithmControls2').style.height = null;
				Effect.BlindDown('SearchTwoAdvancedOptions', { duration: 0.5 });
		} else {
				Effect.BlindUp('SearchTwoAdvancedOptions', { duration: 0.5, afterFinish: function() {$('divAlgorithmControls2').style.height = "32px";}});
		}
	}
	
	$('txtOrganisms1').onblur = function() {
		OrganismTextboxBlur(this);
	}
	
	$('txtOrganisms2').onblur = function() {
		OrganismTextboxBlur(this);
	}
	
	$('txtMutations1').onkeypress = function(e) {
		var evt = (e) ? e : window.event;
		var key = (evt.keyCode) ? evt.keyCode : evt.which;
		
		return isValidDecimalChar(key, $('txtMutations1').value);
	}
	
	$('txtMutations2').onkeypress = function(e) {
		var evt = (e) ? e : window.event;
		var key = (evt.keyCode) ? evt.keyCode : evt.which;
		
		return isValidDecimalChar(key, $('txtMutations2').value);
	}
	
	$('btnViewHistory1').onclick = function() {
		DisplaySearchHistory(objSearch1, objSearch2);
	}
	
	$('btnViewHistory2').onclick = function() {
		DisplaySearchHistory(objSearch1, objSearch2);
	}
	
	$('txtMultiRunsMaxQueries').onkeypress = function(e) {
		var evt = (e) ? e : window.event;
		var key = (evt.keyCode) ? evt.keyCode : evt.which;
		
		return isNumeric(key);
	}
	
	$('txtMultiRunsIterations').onkeypress = function(e) {
		var evt = (e) ? e : window.event;
		var key = (evt.keyCode) ? evt.keyCode : evt.which;
		
		return isNumeric(key);
	}
	
	$('txtMultiRunsStepSize').onkeypress = function(e) {
		var evt = (e) ? e : window.event;
		var key = (evt.keyCode) ? evt.keyCode : evt.which;
		
		return isNumeric(key);
	}
	
	$('chkMultiRunsCutoff').onclick = function() {
		if (this.checked)
			$('divMRQueryCutoffExpanded').morph('width:280px; margin-left: 0px;');
		else 
			$('divMRQueryCutoffExpanded').morph('width:0px; margin-left: -10px;');
	}
	
	$('btnMultiRunsStart').onclick = function() {
		if (typeof objMultiRun == "undefined") objMultiRun = new MultiRunObject();
		objMultiRun.CurrentlyOn = true;
		IsCompleted = false;
		$('btnStartSearch').click();
	}
	
	$('btnMultiRunsReset').onclick = function() {
		objMultiRun = new MultiRunObject();
		$('CompletedIterations').innerHTML = 0;
		$('btnReset').click();
	}
	
	$('btnMultiRunsStop').onclick = function() {
		objMultiRun.CurrentlyOn = false;
		$('btnStop').click();
	}
	
	$('btnViewMultiRunsHistory').onclick = function() {
		DisplaySearchHistoryMulti();
	}

	
	
	//Initialize Algorithm Select boxes
	if (SearchTypes) {
		var opt;
		var ddlNames = new Array('ddlAlgorithms1', 'ddlAlgorithms2');
		for (var j = 0; j < ddlNames.length; j++) {
			while ($(ddlNames[j]).options.length > 0) {
				$(ddlNames[j]).options.remove(0);
			}
		
			for (var i = 0; i < SearchTypes.length; i++) {
				opt = document.createElement('option');
				opt.text = SearchTypes[i];
				opt.value = i;
				
				try {
					$(ddlNames[j]).options.add(opt, null) // standards compliant
				} catch(ex) {
					$(ddlNames[j]).options.add(opt); // IE only
				}
			}
	
			//Make sure defaults to Ev algorithm
			var p = 0;
			while ($(ddlNames[j]).options[$(ddlNames[j]).selectedIndex].text != "Ev Search" && p < 100) {
				$(ddlNames[j]).selectedIndex = p;
				p++;
			}
		}
	}
	
	// Hide tab again
	if (isHidden) {
		jQuery("#tabs #simulation").removeClass("visible").addClass("hidden");
		jQuery(window).scrollTop(0);
	}
});


//Utility functions
function isControlKey(key) {
	return (key == 8 || key == 9 || key == 13);
}

function isNumeric(keyCode) {
	return !(keyCode > 57 || (keyCode > 30 && keyCode < 48));
}

function isValidDecimalChar(keyCode, strCurrent) {
	var strPeriod = '.';
	return  !(((keyCode > 57 || (keyCode > 30 && keyCode < 48)) && keyCode != strPeriod.charCodeAt(0)) || (keyCode == strPeriod.charCodeAt(0) && strCurrent.indexOf(strPeriod) != -1));
}

function removeIllegalChars(obj) {
	var input = obj.value;
	var output = '';
	for (u = 0; u < input.length; u++) {
		if (CurrentAllowedCharacters.indexOf(input.charAt(u)) > -1 ) output += input.charAt(u);
	}
	obj.value = output;
}

function addLoadEvent(func) {
	var origOnload = window.onload;
	
	if (typeof window.onload != 'function') {
		window.onload = func;
	} else {
		window.onload = function() {		
			if (origOnload) {origOnload();}
			func();
		}
	}
}

function isPastCutoff(obj) {
	return (typeof objMultiRun != "undefined" && objMultiRun.CurrentlyOn && $('chkMultiRunsCutoff').checked && obj.GetQueryCount() >= $('txtMultiRunsMaxQueries').value); 
}



/*********** Get HTML for display **************/
function GetMultiRunResults(type1, type2) {
	var output = "<a href=\"#\" onclick=\"$(this.parentNode).innerHTML = objMultiRun.GetHistoryCSV('" + type1 + "','" + type2 + "'); return false;\">View as CSV</a><br/>";
	output += objMultiRun.GetHistoryHTML(type1, type2);
	return output;
}


//Regular Methods
function OrganismTextboxBlur(orgTextBox) {
	var totalOrgs = 0;
	var ddl;

	orgTextBox.value = parseInt(orgTextBox.value, 10) < 1 ? 1 : parseInt(orgTextBox.value, 10);
	orgTextBox.value = parseInt(orgTextBox.value, 10) > 100 ? 100 : parseInt(orgTextBox.value, 10);

	ddl = $('ddlAlgorithms1');
	if (SearchTypes[ddl.options[ddl.selectedIndex].value] == "Ev Search") totalOrgs += parseInt($('txtOrganisms1').value);
	ddl = $('ddlAlgorithms2');
	if (SearchTypes[ddl.options[ddl.selectedIndex].value] == "Ev Search") totalOrgs += parseInt($('txtOrganisms2').value);

	$('txtSteps').value = parseInt(1000 / totalOrgs) > 10 ? 10 : parseInt(1000 / totalOrgs);
}

function ResetSearch() {
	//Reset Search Objects
	if (objSearch1) objSearch1.ResetSearch();
	if (objSearch2) objSearch2.ResetSearch();
	
	//Reset Tables
	ResetTable($('tblResults1'));
	ResetTable($('tblResults2'));

	//Reset output
	$('QueryCount1').innerHTML = 0;
	$('ErrorCount1').innerHTML = 0;
	$('QueryCount2').innerHTML = 0;
	$('ErrorCount2').innerHTML = 0;

	$('txtOrganisms1').readOnly = null;
	$('txtOrganisms2').readOnly = null;
	$('txtOrganisms1').className = null;
	$('txtOrganisms2').className = null;

	currentSearchResultsString1 = null;
	currentSearchResultsString2 = null;

	$('btnStepForward').disabled = false;
	if ($('btnStepForward').value == "Stepping...") $('btnStepForward').value = "Step Forward: ";

	IsCompleted = false;
}

function ResetTable(tblResults) {
	var rowIndex;
	var row;
	var iIndexLength = (tblResults.rows.length + 1) / 3;

	for (var k = 0; k < 2; k++) {
		for (var i = 0; i < iIndexLength; i++) {
			rowIndex = k + (i * 3);
			row = tblResults.rows[rowIndex];
			for (var j = 0; j < 25; j++) {
				row.cells[j].innerHTML = '&nbsp;';
				row.cells[j].className = (row.cells[j].className == 'extraCell' ? 'extraCell' : null);
			}
		}
	}
}

function NotifyUserSearchCompleted() {
	alert('Search Completed. (All targets found.)');
}

function TakeStepForwardMulti() {
	setTimeout("for (n = 0; n < parseInt($('txtMultiRunsStepSize').value, 10) && n < 1000 && !IsCompleted; n++) {TakeStepForward();}", 1);
}

function TakeStepForward() {
	if (IsCompleted) return;

	if (typeof objMultiRun == "undefined") objMultiRun = new MultiRunObject();

	var errorCount1 = 0;
	var errorCount2 = 0;
	var queryCount1 = 0;
	var queryCount2 = 0;

	var alg1 = $('ddlAlgorithms1').options[$('ddlAlgorithms1').selectedIndex].value;
	var alg2 = $('ddlAlgorithms2').options[$('ddlAlgorithms2').selectedIndex].value;

	var numOfOrganisms1 = parseInt($('txtOrganisms1').value);
	var numOfOrganisms2 = parseInt($('txtOrganisms2').value);

	objSearch1 = objSearch1 || new SearchObject();
	objSearch2 = objSearch2 || new SearchObject();

	//Initialize, or step forward if still has errors
	if (!objSearch1.Initialized) {
		errorCount1 = objSearch1.Initialize(CurrentBindingsMode, alg1, numOfOrganisms1);
		DisplayCurrentBindings(objSearch1.GetCurrentTargetArray(), $('tblResults1'), 1, objSearch1.BindingSitesStart);

		//Disable organisms text box if Ev search in progress
		if (SearchTypes[alg1] == "Ev Search") {
			$('txtOrganisms1').readOnly = true;
			$('txtOrganisms1').className = "ReadOnlyTextbox";
		}
	} else if (objSearch1.GetErrorCount() > 0 && !isPastCutoff(objSearch1)) {
		errorCount1 = objSearch1.StepForward(parseFloat($('txtMutations1').value), parseFloat($('txtSurvivalPct1').value));
	}

	if (!objSearch2.Initialized) {
		errorCount2 = objSearch2.Initialize(CurrentBindingsMode, alg2, numOfOrganisms2);
		DisplayCurrentBindings(objSearch2.GetCurrentTargetArray(), $('tblResults2'), 1, objSearch2.BindingSitesStart);

		//Disable organisms text box if Ev search in progress
		if (SearchTypes[alg2] == "Ev Search") {
			$('txtOrganisms2').readOnly = true;
			$('txtOrganisms2').className = "ReadOnlyTextbox";
		}
	} else if (objSearch2.GetErrorCount() > 0 && !isPastCutoff(objSearch2)) {
		errorCount2 = objSearch2.StepForward(parseFloat($('txtMutations2').value), parseFloat($('txtSurvivalPct2').value));
	}


	//Show Current Bindings output
	if (currentSearchResultsString1 != objSearch1.GetCurrentBindingsString()) {
		currentSearchResultsString1 =  objSearch1.GetCurrentBindingsString();
		DisplayCurrentBindings(objSearch1.GetCurrentBindingsArray(), $('tblResults1'), 0, objSearch1.BindingSitesStart);
	}
		
	if (currentSearchResultsString2 != objSearch2.GetCurrentBindingsString()) {
		currentSearchResultsString2 =  objSearch2.GetCurrentBindingsString();
		DisplayCurrentBindings(objSearch2.GetCurrentBindingsArray(), $('tblResults2'), 0, objSearch2.BindingSitesStart);
	}

	//Get query counts
	queryCount1 = objSearch1.GetQueryCount();
	queryCount2 = objSearch2.GetQueryCount();

	$('QueryCount1').innerHTML = queryCount1;
	$('ErrorCount1').innerHTML = errorCount1;
	$('QueryCount2').innerHTML = queryCount2;
	$('ErrorCount2').innerHTML = errorCount2;

	$('Search1MutationsLabel').title = "Average Number of Mutations Per Replication: " + (Math.round((objSearch1.GetMutationCount() / (queryCount1 - numOfOrganisms1)) * 100) / 100);
	$('Search2MutationsLabel').title = "Average Number of Mutations Per Replication: " + (Math.round((objSearch2.GetMutationCount() / (queryCount2 - numOfOrganisms2)) * 100) / 100);

	//If we've found all targets, stop search.
	if ((!IsCompleted && errorCount1 == 0 && errorCount2 == 0) || (isPastCutoff(objSearch1) && isPastCutoff(objSearch2))) {
		//If in multi-mode and have not reached limit, save results and update counter display
		if (objMultiRun.CurrentlyOn && objMultiRun.Runs.length < $('txtMultiRunsIterations').value) {
			objMultiRun.SaveRunResults(objSearch1, objSearch2);
			$('CompletedIterations').innerHTML = objMultiRun.Runs.length;
		}

		//If in multi-mode, reset and start next iteration, until limit. If not, notify user that search has ended.		
		if (objMultiRun.CurrentlyOn && objMultiRun.Runs.length < $('txtMultiRunsIterations').value) { 			
			$('btnReset').click();
			$('btnStartSearch').click();
		} else {
			objMultiRun.CurrentlyOn = false;
			$('btnStop').click();
			NotifyUserSearchCompleted();
			IsCompleted = true;
		}
	}
}

function DisplayCurrentBindings(arrBindings, tblResults, firstRow, bindingSitesStart) {
	var rowIndex;
	var arrayOffset;
	var val;
	var row;
	var classPrefix = ((firstRow > 0) ? "Target" : "Binding");
	var iIndexLength = (tblResults.rows.length + 1) / 3;

	for (var i = 0; i < iIndexLength; i++) {
		rowIndex = firstRow + (i * 3);
		row = tblResults.rows[rowIndex];

		for (var j = 0; j < 25; j++) {
			arrayOffset = bindingSitesStart + ((i * 25) + j);

			if (arrayOffset > 255) break;

			val = arrBindings[arrayOffset] == 1 ? 1 : 0;
			row.cells[j].innerHTML = val;
			row.cells[j].className = classPrefix + "Site_" + val;
		}
	}
}

function DisplaySearchHistory(obj1, obj2) {
	var alg1 = $('ddlAlgorithms1').options[$('ddlAlgorithms1').selectedIndex].value;
	var alg2 = $('ddlAlgorithms2').options[$('ddlAlgorithms2').selectedIndex].value;
	var titleTop = "History: " + SearchTypes[alg1] + " vs. " + SearchTypes[alg2];
	var text1 = objSearch1.GetHistoryFormatted(SearchTypes[alg1], false);
	var text2 = objSearch2.GetHistoryFormatted(SearchTypes[alg2], false);
	var text = "Query / Error Count (<span id='spnHistoryMode'>Last 500 Queries</span>)<br /><br />\n<div id='divSearchHistory1'>" + text1 + "</div><div id='divSearchHistory2'>" + text2 + "</div>";
	text += "<div id='divSearchHistoryFull'><a href='ev#' onclick='ShowFullHistory(this.parentNode); return false;'>View Full History</a></div>";

	Shadowbox.open({
			player:     'html',
			title:    	titleTop,
			content:    text,
			height:     600,
			width:      540
		});
	
}

function DisplaySearchHistoryMulti() {
	var alg1 = $('ddlAlgorithms1').options[$('ddlAlgorithms1').selectedIndex].value;
	var alg2 = $('ddlAlgorithms2').options[$('ddlAlgorithms2').selectedIndex].value;
	var text = GetMultiRunResults(SearchTypes[alg1], SearchTypes[alg2]);

	Shadowbox.open({
		player:     'html',
		title:      'History: Multi-Runs Mode',
		content:    text,
		height:     506,
		width:      460
	});
}

function ShowFullHistory(divMain) {
	var alg1 = $('ddlAlgorithms1').options[$('ddlAlgorithms1').selectedIndex].value;
	var alg2 = $('ddlAlgorithms2').options[$('ddlAlgorithms2').selectedIndex].value;
	var titleTop = "History: " + SearchTypes[alg1] + " vs. " + SearchTypes[alg2];	
	var div1 = $('divSearchHistory1');
	var div2 = $('divSearchHistory2');
	var div3 = $('divSearchHistoryFull');

	div1.innerHTML = SearchTypes[alg1] + "<br />\n<hr />\n";
	div2.innerHTML = SearchTypes[alg2] + "<br />\n<hr />\n";
	div3.innerHTML = "Loading...";

	$('spnHistoryMode').innerHTML = "Full History";

	if (interHistoryID) clearInterval(interHistoryID);
	AddHistoryLine.i = -1;	//Reset the index, -1 since increments by +1 on entry
	interHistoryID = setInterval("AddHistoryLine()", 1);
}

function AddHistoryLine() {
	var div1 = $('divSearchHistory1');
	var div2 = $('divSearchHistory2');

	var arrHistory1 = objSearch1.GetHistoryArray();
	var arrHistory2 = objSearch2.GetHistoryArray();
	AddHistoryLine.i = ++AddHistoryLine.i || 0;

	var maxLength = arrHistory1.length > arrHistory2.length ? arrHistory1.length : arrHistory2.length;

	if  (AddHistoryLine.i >= maxLength) {
		if (interHistoryID) clearInterval(interHistoryID);
		$('divSearchHistoryFull').innerHTML = "";
	} else {
		if (typeof arrHistory1[AddHistoryLine.i] != "undefined") div1.innerHTML += (AddHistoryLine.i + 1) + ') ' + arrHistory1[AddHistoryLine.i] + "<br />\n";
		if (typeof arrHistory2[AddHistoryLine.i] != "undefined") div2.innerHTML += (AddHistoryLine.i + 1) + ') ' + arrHistory2[AddHistoryLine.i] + "<br />\n";
	}
}

